/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package alignmentsystemexp;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.StringTokenizer;

/**
 *
 * @author ckr
 */
public class Main {
    public static Map<CreatureType, Creature> typeToCre = new HashMap<CreatureType, Creature>();
    public static String workingDir = "/home/ckr/Desktop/";

    public static Vector randPointInBall(double radius, Vector origin){
        double r = Math.random() * radius;
        double[] angles = new double[origin.getDimension()-1];
        for(int i=0; i<angles.length; i++){
            angles[i] = Math.random() * 2 * Math.PI;
        }
        Vector res = new Vector(origin.getDimension());
        double[] resarray = res.getArray();
        for (int i = 0; i < resarray.length; i++) {
            resarray[i] = r;
        }
        for (int i = 0; i < resarray.length; i++) {
            for (int j = 0; j < i; j++) {
                resarray[i] *= Math.sin(angles[j]);
            }
            if(i <= angles.length-1){
                resarray[i] *= Math.cos(angles[i]);
            }else{
                resarray[i] *= Math.sin(angles[angles.length-1]);
            }
        }
        /*if(!(Math.sqrt(res.dot(res)) == r)){
            System.err.println("Bad: " + Math.sqrt(res.dot(res)) + " " + r);
            System.exit(0);
        }*/
        return res.add(origin);
    }

    public static Vector forcePoint(Vector vector){
        double[] v = vector.getArray();
        double[] newv = new double[v.length];
        for(int i=0; i<v.length; i++){
            newv[i] = v[i];
            if(newv[i] > 1.0){
                newv[i] = 1.0;
            }
            if(newv[i] < -1.0){
                newv[i] = -1.0;
            }
        }
        return new Vector(newv);
    }

    public static void generateCreatures(double alignRad, double allieRad) throws IOException{
        PrintStream out = new PrintStream(new FileOutputStream(workingDir + "creatures.dat"));
        out.println("Faction   AE  OC  PV   HuA   CorA   ConA   UnA   ElA   MeA");
        // Faction base points
        Vector[] alignStart = {
            new Alignment(0.0, 0.0, 0.05),
            new Alignment(0.5, 0.50, 0.65),
            new Alignment(0.1, -0.65, 0.65),
            new Alignment(-0.65, 0.50, 0.60),
            new Alignment(0.60, -0.20, -0.55),
            new Alignment(-0.50, -0.05, -0.65)};

        // Output files
        PrintStream[] alignFiles = {
            new PrintStream(new FileOutputStream(workingDir + "fa1.dat")),
            new PrintStream(new FileOutputStream(workingDir + "fa2.dat")),
            new PrintStream(new FileOutputStream(workingDir + "fa3.dat")),
            new PrintStream(new FileOutputStream(workingDir + "fa4.dat")),
            new PrintStream(new FileOutputStream(workingDir + "fa5.dat")),
            new PrintStream(new FileOutputStream(workingDir + "fa6.dat"))};

        // Faction base points
        Vector[] alliesStart = {
            new Allies(0.8, 0.0, 0.0, 0.0, 0.0, 0.0),
            new Allies(0.0, 0.8, 0.0, 0.0, 0.0, 0.0),
            new Allies(0.0, 0.0, 0.8, 0.0, 0.0, 0.0),
            new Allies(0.0, 0.0, 0.0, 0.8, 0.0, 0.0),
            new Allies(0.0, 0.0, 0.0, 0.0, 0.8, 0.0),
            new Allies(0.0, 0.0, 0.0, 0.0, 0.0, 0.8)};

        // Output files
        PrintStream[] alliesFiles = {
            new PrintStream(new FileOutputStream(workingDir + "ff1.dat")),
            new PrintStream(new FileOutputStream(workingDir + "ff2.dat")),
            new PrintStream(new FileOutputStream(workingDir + "ff3.dat")),
            new PrintStream(new FileOutputStream(workingDir + "ff4.dat")),
            new PrintStream(new FileOutputStream(workingDir + "ff5.dat")),
            new PrintStream(new FileOutputStream(workingDir + "ff6.dat"))};

        for(int i = 0; i < 6; i++){
            out.println(CreatureType.values()[i*20] + " " + alignStart[i] + " " + alliesStart[i]);
            alignFiles[i].println(alignStart[i]);
            alliesFiles[i].println(alliesStart[i]);
            for (int j = 0; j < 19; j++) {
                Vector alignPoint = forcePoint(randPointInBall(alignRad, alignStart[i]));
                Vector alliesPoint = forcePoint(randPointInBall(allieRad, alliesStart[i]));
                out.println(CreatureType.values()[i*20+j+1] + " " + alignPoint + " " + alliesPoint);
                alignFiles[i].println(alignPoint);
                alliesFiles[i].println(alliesPoint);
            }
        }
    }

    public static Keeper loadFile(String filename, double evolveRate, int maxCreatures) throws FileNotFoundException, IOException{
        BufferedReader br = new BufferedReader(new FileReader(filename));
        List<Creature> creaturePool = new ArrayList<Creature>();
        br.readLine();
        String line = br.readLine();
        while(line != null){
            StringTokenizer st = new StringTokenizer(line);
            String type = st.nextToken(),
                   ae = st.nextToken(),
                   oc = st.nextToken(),
                   pv = st.nextToken(),
                   hu = st.nextToken(),
                   cor = st.nextToken(),
                   con = st.nextToken(),
                   un = st.nextToken(),
                   el = st.nextToken(),
                   me = st.nextToken();
            Creature c = new Creature(new SvenskmandAppearance(30.0, 3.0), CreatureType.valueOf(type),
                    Double.parseDouble(hu),
                    Double.parseDouble(cor),
                    Double.parseDouble(con),
                    Double.parseDouble(un),
                    Double.parseDouble(el),
                    Double.parseDouble(me),
                    Double.parseDouble(ae),
                    Double.parseDouble(oc),
                    Double.parseDouble(pv));
            creaturePool.add(c);
            typeToCre.put(CreatureType.valueOf(type), c);
            line = br.readLine();
        }
        return new Keeper(new SvenskmandStatistics(), creaturePool, new ArrayList<Creature>(),
                new Allies(), new Alignment(), evolveRate, maxCreatures, 1);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws FileNotFoundException, IOException {
        //generateCreatures(0.8, 0.3);
        
        /*System.out.println(computeAlignment(new CreatureType[]{
            CreatureType.UnC7,
            CreatureType.UnC20,
            CreatureType.UnC20,
            CreatureType.UnC5,
            CreatureType.UnC5,
            CreatureType.UnC4,
            CreatureType.UnC9,
            CreatureType.UnC13,
            CreatureType.UnC6,
            CreatureType.UnC14,
            CreatureType.UnC17,
            CreatureType.UnC10,
            CreatureType.UnC15,
            CreatureType.UnC9,
            CreatureType.UnC10,
            CreatureType.UnC11,
            CreatureType.UnC2,
            CreatureType.UnC12,
            CreatureType.UnC1,
            CreatureType.UnC1
        }));//*/

        testInterActive();

        //testConvergeTo(new Alignment(0.1, -0.65, 0.65), 0.4, 0.5, 20);
        /*Set<CreatureType> wanted = new HashSet<CreatureType>();
        wanted.add(CreatureType.MeC5);
        wanted.add(CreatureType.MeC6);
        wanted.add(CreatureType.MeC7);
        wanted.add(CreatureType.MeC8);
        wanted.add(CreatureType.MeC9);
        wanted.add(CreatureType.MeC10);
        wanted.add(CreatureType.MeC12);
        wanted.add(CreatureType.MeC14);
        wanted.add(CreatureType.MeC16);
        //wanted.add(CreatureType.CorC11);
        //wanted.add(CreatureType.CorC12);
        //wanted.add(CreatureType.CorC13);
        //wanted.add(CreatureType.CorC14);
        //wanted.add(CreatureType.CorC15);
        testWantCreatures(wanted, 0.5, 20);//*/
    }

    public static Alignment computeAlignment(CreatureType[] creatureTypes) throws FileNotFoundException, IOException{
        Keeper keeper = loadFile(workingDir + "creatures.dat", 1.0, 20);
        List<Creature> creatures = new LinkedList<Creature>();
        for(CreatureType t : creatureTypes){
            creatures.add(typeToCre.get(t));
        }
        Alignment creatureAlignment = new Alignment();
        for (Creature c : creatures) {
            creatureAlignment = new Alignment((creatureAlignment.add(c.getAlignment())).getArray());
        }
        if (creatures.size() > 0) {
            creatureAlignment = new Alignment((creatureAlignment.scale(1.0 / creatures.size())).getArray());
        }
        return creatureAlignment;
    }

    public static void testInterActive() throws FileNotFoundException, IOException{
        PrintStream walk = new PrintStream(new FileOutputStream(workingDir + "walk.dat"));
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

        Keeper keeper = loadFile(workingDir + "creatures.dat", 1.0, 20);

        System.out.println("Input starting alignment");
        StringTokenizer st = new StringTokenizer(br.readLine());
        keeper.setAlignment(new Alignment(
                Double.parseDouble(st.nextToken()),
                Double.parseDouble(st.nextToken()),
                Double.parseDouble(st.nextToken())));
        walk.println(keeper.getAlignment());

        System.out.println("Input evolve rate");
        keeper.setEvolveRate(Double.parseDouble(br.readLine()));
        
        int i = 0;
        while (true) {
            System.out.println("Creature pool probabilities");
            for (Creature c : keeper.getCreaturePool()) {
                System.out.println(c.getType() + " " + c.appearProb(keeper));
            }
            System.out.println("Before " + i + ": " + keeper.printCreatures());
            if(keeper.getCreatures().size() < 20){
                keeper.waitForCreature();
                keeper.updateStatistics();
            }
            walk.println(keeper.getAlignment());
            System.out.println("After  " + i + ": " + keeper.printCreatures());
            System.out.println("Current allignment " + keeper.getAlignment());
            System.out.println("Select creature to evict (hit enter to select none)");

            st = new StringTokenizer(br.readLine());
            List<Integer> removed = new LinkedList<Integer>();
            int totalRemoved = 0;
            while(st.hasMoreTokens()){
                int remove = Integer.parseInt(st.nextToken());
                removed.add(remove);
                keeper.getCreatures().remove(remove-totalRemoved-1);
                totalRemoved++;
            }
            System.out.print("The chosen numbers are ");
            for(Integer num : removed){
                System.out.print(num + " ");
            }
            System.out.println();
            if(totalRemoved > 0){
                keeper.updateStatistics();
            }
            walk.println(keeper.getAlignment());
        }
    }

    public static void testWantCreatures(Set<CreatureType> wantedtypes, double evolveRate, int maxCreatures) throws FileNotFoundException, IOException{
        Keeper keeper = loadFile(workingDir + "creatures.dat", evolveRate, maxCreatures);
        PrintStream walk = new PrintStream(new FileOutputStream(workingDir + "walk.dat"));

        for(int i=0; i<keeper.getMaxCreatures(); i++){
            keeper.waitForCreature();
            keeper.updateStatistics();
        }
        int i=1;
        while(!containsAllWanted(wantedtypes, keeper.getCreatures())){
            if(keeper.evictNonWanted(wantedtypes)){
                keeper.updateStatistics();
                keeper.waitForCreature();
                keeper.updateStatistics();
                //System.out.println(i + ": " + keeper.printCreatures());
                //System.out.println(keeper.getAlignment());
                walk.println(keeper.getAlignment());
            }
            i++;
        }
    }

    public static void testConvergeTo(Alignment target, double radius, double evolveRate, int maxCreatures)
            throws FileNotFoundException, IOException{
        Keeper keeper = loadFile(workingDir + "creatures.dat", evolveRate, maxCreatures);

        PrintStream walk = new PrintStream(new FileOutputStream(workingDir + "walk.dat"));

        for(int i=0; i<keeper.getMaxCreatures(); i++){
            keeper.waitForCreature();
            keeper.updateStatistics();
        }
        //System.out.println(keeper.getAlignment());
        walk.println(keeper.getAlignment());
        int i=1;
        while(target.LpDistance(keeper.getAlignment(), 2.0) > radius){
            keeper.evictCreatures(target, maxCreatures/2+1);
            keeper.updateStatistics();
            for (int j = 0; j < maxCreatures/2+1; j++) {
                keeper.waitForCreature();
                keeper.updateStatistics();
            }
            keeper.updateStatistics();
            i++;
            //System.out.println(keeper.getAlignment());
            //System.out.println(keeper.printCreatures());
            walk.println(keeper.getAlignment());
        }
    }

    public static boolean containsAllWanted(Set<CreatureType> wanted, List<Creature> creatures){
        Set<CreatureType> gotten = new HashSet<CreatureType>();
        for(Creature c : creatures){
            gotten.add(c.getType());
        }
        return gotten.containsAll(wanted);
    }
}
