/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package alignmentsystemexp;

/**
 *
 * @author ckr
 */
public class Vector {
    protected double[] vector;

    public Vector(int size){
        this.vector = new double[size];
    }

    public Vector(double[] vector){
        this.vector = vector;
    }

    public int getDimension(){
        return vector.length;
    }

    public double[] getArray(){
        return vector;
    }

    public Vector add(Vector other){
        if(vector.length != other.vector.length){
            // Todo Handle vector dimension mismatch by throwing a exception
            System.err.println("Vector dimension error");
            System.exit(0);
        }
        double[] res = new double[vector.length];
        for(int i=0; i<vector.length; i++){
            res[i] = vector[i] + other.vector[i];
        }
        return new Vector(res);
    }

    public Vector sub(Vector other){
        if(vector.length != other.vector.length){
            // Todo Handle vector dimension mismatch by throwing a exception
            System.err.println("Vector dimension error");
            System.exit(0);
        }
        double[] res = new double[vector.length];
        for(int i=0; i<vector.length; i++){
            res[i] = vector[i] - other.vector[i];
        }
        return new Vector(res);
    }

    public Vector scale(double scale){
        double[] res = new double[vector.length];
        for(int i=0; i<vector.length; i++){
            res[i] = scale * vector[i];
        }
        return new Vector(res);
    }

    public double dot(Vector other){
        if(vector.length != other.vector.length){
            // Todo Handle vector dimension mismatch by throwing a exception
            System.err.println("Vector dimension error");
            System.exit(0);
        }
        double res = 0.0;
        for(int i=0; i<vector.length; i++){
            res += vector[i] * other.vector[i];
        }
        return res;
    }

    /**
     * Computes the L_p distance for p >= 1
     * @param other
     * @return
     */
    public double LpDistance(Vector other, double p){
        if(vector.length != other.vector.length){
            // Todo Handle vector dimension mismatch by throwing a exception
            System.err.println("Vector dimension error");
            System.exit(0);
        }
        if(p < 1.0){
            // Todo Handle vector dimension mismatch by throwing a exception
            System.err.println("Cannot compute L_p distance for p < 1");
            System.exit(0);
        }
        double res = 0.0;
        for(int i=0; i<vector.length; i++){
            res += Math.pow(Math.abs(vector[i] - other.vector[i]), p);
        }
        return Math.pow(res, 1/p);
    }

    @Override
    public String toString(){
        String res = "";
        for(int i=0; i<vector.length-1; i++){
            res += vector[i] + " ";
        }
        res += vector[vector.length-1];
        return res;
    }
}
